# Class MapBinding<K,V>

java.lang.Object
javafx.beans.binding.MapExpression<K,V>
javafx.beans.binding.MapBinding<K,V>

Type Parameters:
  `K` - the type of the key elements
  `V` - the type of the value elements

All Implemented Interfaces:
  `Map<K,V>, Binding<ObservableMap<K,V>>, Observable, ObservableMapValue<K,V>, ObservableObjectValue<ObservableMap<K,V>>, ObservableValue<ObservableMap<K,V>>, ObservableMap<K,V>`

public abstract class MapBinding<K,V> extends MapExpression<K,V> implements Binding<ObservableMap<K,V>>
Base class that provides most of the functionality needed to implement a `Binding` of an `ObservableMap`.

`MapBinding` provides a simple invalidation-scheme. An extending class can register dependencies by calling `bind(Observable...)`. If one of the registered dependencies becomes invalid, this `MapBinding` is marked as invalid. With `unbind(Observable...)` listening to dependencies can be stopped.

To provide a concrete implementation of this class, the method `computeValue()` has to be implemented to calculate the value of this binding based on the current state of the dependencies. It is called when `get()` is called for an invalid binding.

See `DoubleBinding` for an example how this base class can be extended.

Since:
  JavaFX 2.1
See Also:
  - `Binding`
  - `MapExpression`

- ## Nested Class Summary

  ### Nested classes/interfaces declared in interface Map

  `Map.Entry<K,V>`

- ## Property Summary

  Properties
  Type
  Property
  Description
  `ReadOnlyBooleanProperty`
  `empty`
  A boolean property that is `true`, if the map is empty.
  `ReadOnlyIntegerProperty`
  `size`
  An integer property that represents the size of the map.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MapBinding()`
  Creates a default `MapBinding`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addListener(InvalidationListener listener)`
  Adds an `InvalidationListener` which will be notified whenever the `Observable` becomes invalid.
  `void`
  `addListener(ChangeListener<? super ObservableMap<K,V>> listener)`
  Adds a `ChangeListener` which will be notified whenever the value of the `ObservableValue` changes.
  `void`
  `addListener(MapChangeListener<? super K, ? super V> listener)`
  Add a listener to this observable map.
  `protected final void`
  `bind(Observable... dependencies)`
  Start observing the dependencies for changes.
  `protected abstract ObservableMap<K,V>`
  `computeValue()`
  Calculates the current value of this binding.
  `void`
  `dispose()`
  A default implementation of `dispose()` that is empty.
  `ReadOnlyBooleanProperty`
  `emptyProperty()`
  A boolean property that is `true`, if the map is empty.
  `final ObservableMap<K,V>`
  `get()`
  Returns the result of `computeValue()`.
  `ObservableList<?>`
  `getDependencies()`
  A default implementation of `getDependencies()` that returns an empty `ObservableList`.
  `final void`
  `invalidate()`
  Mark a binding as invalid.
  `final boolean`
  `isValid()`
  Checks if a binding is valid.
  `protected void`
  `onInvalidating()`
  The method onInvalidating() can be overridden by extending classes to react, if this binding becomes invalid.
  `void`
  `removeListener(InvalidationListener listener)`
  Removes the given listener from the list of listeners, that are notified whenever the value of the `Observable` becomes invalid.
  `void`
  `removeListener(ChangeListener<? super ObservableMap<K,V>> listener)`
  Removes the given listener from the list of listeners that are notified whenever the value of the `ObservableValue` changes.
  `void`
  `removeListener(MapChangeListener<? super K, ? super V> listener)`
  Tries to removed a listener from this observable map.
  `ReadOnlyIntegerProperty`
  `sizeProperty()`
  An integer property that represents the size of the map.
  `String`
  `toString()`
  Returns a string representation of this `MapBinding` object.
  `protected final void`
  `unbind(Observable... dependencies)`
  Stop observing the dependencies for changes.

  ### Methods declared in class MapExpression

  `asString, clear, containsKey, containsValue, entrySet, get, getSize, getValue, isEmpty, isEqualTo, isNotEqualTo, isNotNull, isNull, keySet, mapExpression, put, putAll, remove, size, valueAt, valueAt, values`

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods declared in interface Map

  `compute, computeIfAbsent, computeIfPresent, equals, forEach, getOrDefault, hashCode, merge, putIfAbsent, remove, replace, replace, replaceAll`

  ### Methods declared in interface Observable

  `subscribe`

  ### Methods declared in interface ObservableValue

  `flatMap, getValue, map, orElse, subscribe, subscribe, when`

- ## Property Details

  - ### size

    public ReadOnlyIntegerProperty sizeProperty
    Specified by:
      `sizeProperty` in class `MapExpression<K,V>`
    Returns:
      the property
    See Also:
      - `sizeProperty()`

  - ### empty

    public ReadOnlyBooleanProperty emptyProperty
    Specified by:
      `emptyProperty` in class `MapExpression<K,V>`
    Returns:
      the `ReadOnlyBooleanProperty`
    See Also:
      - `emptyProperty()`

- ## Constructor Details

  - ### MapBinding

    public MapBinding()
    Creates a default `MapBinding`.

- ## Method Details

  - ### sizeProperty

    public ReadOnlyIntegerProperty sizeProperty()
    Description copied from class: `MapExpression`
    An integer property that represents the size of the map.
    Specified by:
      `sizeProperty` in class `MapExpression<K,V>`
    Returns:
      the `size` property

  - ### emptyProperty

    public ReadOnlyBooleanProperty emptyProperty()
    Description copied from class: `MapExpression`
    A boolean property that is `true`, if the map is empty.
    Specified by:
      `emptyProperty` in class `MapExpression<K,V>`
    Returns:
      the `empty` property

  - ### addListener

    public void addListener(InvalidationListener listener)
    Description copied from interface: `Observable`
    Adds an `InvalidationListener` which will be notified whenever the `Observable` becomes invalid. If the same listener is added more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

    Note that the same actual `InvalidationListener` instance may be safely registered for different `Observables`.

    The `Observable` stores a strong reference to the listener which will prevent the listener from being garbage collected and may result in a memory leak. It is recommended to either unregister a listener by calling `removeListener` after use or to use an instance of `WeakInvalidationListener` avoid this situation.

    Specified by:
      `addListener` in interface `Observable`
    Parameters:
      `listener` - The listener to register
    See Also:
      - `Observable.removeListener(InvalidationListener)`

  - ### removeListener

    public void removeListener(InvalidationListener listener)
    Description copied from interface: `Observable`
    Removes the given listener from the list of listeners, that are notified whenever the value of the `Observable` becomes invalid.

    If the given listener has not been previously registered (i.e. it was never added) then this method call is a no-op. If it had been previously added then it will be removed. If it had been added more than once, then only the first occurrence will be removed.

    Specified by:
      `removeListener` in interface `Observable`
    Parameters:
      `listener` - The listener to remove
    See Also:
      - `Observable.addListener(InvalidationListener)`

  - ### addListener

    public void addListener(ChangeListener<? super ObservableMap<K,V>> listener)
    Description copied from interface: `ObservableValue`
    Adds a `ChangeListener` which will be notified whenever the value of the `ObservableValue` changes. If the same listener is added more than once, then it will be notified more than once. That is, no check is made to ensure uniqueness.

    Note that the same actual `ChangeListener` instance may be safely registered for different `ObservableValues`.

    The `ObservableValue` stores a strong reference to the listener which will prevent the listener from being garbage collected and may result in a memory leak. It is recommended to either unregister a listener by calling `removeListener` after use or to use an instance of `WeakChangeListener` avoid this situation.

    Specified by:
      `addListener` in interface `ObservableValue<K>`
    Parameters:
      `listener` - The listener to register
    See Also:
      - `ObservableValue.removeListener(ChangeListener)`

  - ### removeListener

    public void removeListener(ChangeListener<? super ObservableMap<K,V>> listener)
    Description copied from interface: `ObservableValue`
    Removes the given listener from the list of listeners that are notified whenever the value of the `ObservableValue` changes.

    If the given listener has not been previously registered (i.e. it was never added) then this method call is a no-op. If it had been previously added then it will be removed. If it had been added more than once, then only the first occurrence will be removed.

    Specified by:
      `removeListener` in interface `ObservableValue<K>`
    Parameters:
      `listener` - The listener to remove
    See Also:
      - `ObservableValue.addListener(ChangeListener)`

  - ### addListener

    public void addListener(MapChangeListener<? super K, ? super V> listener)
    Description copied from interface: `ObservableMap`
    Add a listener to this observable map.
    Specified by:
      `addListener` in interface `ObservableMap<K,V>`
    Parameters:
      `listener` - the listener for listening to the list changes

  - ### removeListener

    public void removeListener(MapChangeListener<? super K, ? super V> listener)
    Description copied from interface: `ObservableMap`
    Tries to removed a listener from this observable map. If the listener is not attached to this map, nothing happens.
    Specified by:
      `removeListener` in interface `ObservableMap<K,V>`
    Parameters:
      `listener` - a listener to remove

  - ### bind

    protected final void bind(Observable... dependencies)
    Start observing the dependencies for changes. If the value of one of the dependencies changes, the binding is marked as invalid.
    Parameters:
      `dependencies` - the dependencies to observe

  - ### unbind

    protected final void unbind(Observable... dependencies)
    Stop observing the dependencies for changes.
    Parameters:
      `dependencies` - the dependencies to stop observing

  - ### dispose

    public void dispose()
    A default implementation of `dispose()` that is empty.
    Specified by:
      `dispose` in interface `Binding<K>`

  - ### getDependencies

    public ObservableList<?> getDependencies()
    A default implementation of `getDependencies()` that returns an empty `ObservableList`.
    Specified by:
      `getDependencies` in interface `Binding<K>`
    Returns:
      an empty `ObservableList`

  - ### get

    public final ObservableMap<K,V> get()
    Returns the result of `computeValue()`. The method `computeValue()` is only called if the binding is invalid. The result is cached and returned if the binding did not become invalid since the last call of `get()`.
    Specified by:
      `get` in interface `ObservableObjectValue<K>`
    Returns:
      the current value

  - ### onInvalidating

    protected void onInvalidating()
    The method onInvalidating() can be overridden by extending classes to react, if this binding becomes invalid. The default implementation is empty.

  - ### invalidate

    public final void invalidate()
    Description copied from interface: `Binding`
    Mark a binding as invalid. This forces the recalculation of the value of the `Binding` next time it is request.
    Specified by:
      `invalidate` in interface `Binding<K>`

  - ### isValid

    public final boolean isValid()
    Description copied from interface: `Binding`
    Checks if a binding is valid.
    Specified by:
      `isValid` in interface `Binding<K>`
    Returns:
      `true` if the `Binding` is valid, `false` otherwise

  - ### computeValue

    protected abstract ObservableMap<K,V> computeValue()
    Calculates the current value of this binding.

    Classes extending `MapBinding` have to provide an implementation of `computeValue`.

    Returns:
      the current value

  - ### toString

    public String toString()
    Returns a string representation of this `MapBinding` object.
    Overrides:
      `toString` in class `Object`
    Returns:
      a string representation of this `MapBinding` object.